// Code generated by go-swagger; DO NOT EDIT.

package waypoint

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"

	"github.com/hashicorp/waypoint/pkg/client/gen/models"
)

// NewWaypointDecodeTokenParams creates a new WaypointDecodeTokenParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewWaypointDecodeTokenParams() *WaypointDecodeTokenParams {
	return &WaypointDecodeTokenParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewWaypointDecodeTokenParamsWithTimeout creates a new WaypointDecodeTokenParams object
// with the ability to set a timeout on a request.
func NewWaypointDecodeTokenParamsWithTimeout(timeout time.Duration) *WaypointDecodeTokenParams {
	return &WaypointDecodeTokenParams{
		timeout: timeout,
	}
}

// NewWaypointDecodeTokenParamsWithContext creates a new WaypointDecodeTokenParams object
// with the ability to set a context for a request.
func NewWaypointDecodeTokenParamsWithContext(ctx context.Context) *WaypointDecodeTokenParams {
	return &WaypointDecodeTokenParams{
		Context: ctx,
	}
}

// NewWaypointDecodeTokenParamsWithHTTPClient creates a new WaypointDecodeTokenParams object
// with the ability to set a custom HTTPClient for a request.
func NewWaypointDecodeTokenParamsWithHTTPClient(client *http.Client) *WaypointDecodeTokenParams {
	return &WaypointDecodeTokenParams{
		HTTPClient: client,
	}
}

/*
WaypointDecodeTokenParams contains all the parameters to send to the API endpoint

	for the waypoint decode token operation.

	Typically these are written to a http.Request.
*/
type WaypointDecodeTokenParams struct {

	// Body.
	Body *models.HashicorpWaypointDecodeTokenRequest

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the waypoint decode token params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *WaypointDecodeTokenParams) WithDefaults() *WaypointDecodeTokenParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the waypoint decode token params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *WaypointDecodeTokenParams) SetDefaults() {
	// no default values defined for this parameter
}

// WithTimeout adds the timeout to the waypoint decode token params
func (o *WaypointDecodeTokenParams) WithTimeout(timeout time.Duration) *WaypointDecodeTokenParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the waypoint decode token params
func (o *WaypointDecodeTokenParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the waypoint decode token params
func (o *WaypointDecodeTokenParams) WithContext(ctx context.Context) *WaypointDecodeTokenParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the waypoint decode token params
func (o *WaypointDecodeTokenParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the waypoint decode token params
func (o *WaypointDecodeTokenParams) WithHTTPClient(client *http.Client) *WaypointDecodeTokenParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the waypoint decode token params
func (o *WaypointDecodeTokenParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithBody adds the body to the waypoint decode token params
func (o *WaypointDecodeTokenParams) WithBody(body *models.HashicorpWaypointDecodeTokenRequest) *WaypointDecodeTokenParams {
	o.SetBody(body)
	return o
}

// SetBody adds the body to the waypoint decode token params
func (o *WaypointDecodeTokenParams) SetBody(body *models.HashicorpWaypointDecodeTokenRequest) {
	o.Body = body
}

// WriteToRequest writes these params to a swagger request
func (o *WaypointDecodeTokenParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error
	if o.Body != nil {
		if err := r.SetBodyParam(o.Body); err != nil {
			return err
		}
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
