// Code generated by go-swagger; DO NOT EDIT.

package waypoint

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"

	"github.com/hashicorp/waypoint/pkg/client/gen/models"
)

// NewWaypointExpediteStatusReportParams creates a new WaypointExpediteStatusReportParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewWaypointExpediteStatusReportParams() *WaypointExpediteStatusReportParams {
	return &WaypointExpediteStatusReportParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewWaypointExpediteStatusReportParamsWithTimeout creates a new WaypointExpediteStatusReportParams object
// with the ability to set a timeout on a request.
func NewWaypointExpediteStatusReportParamsWithTimeout(timeout time.Duration) *WaypointExpediteStatusReportParams {
	return &WaypointExpediteStatusReportParams{
		timeout: timeout,
	}
}

// NewWaypointExpediteStatusReportParamsWithContext creates a new WaypointExpediteStatusReportParams object
// with the ability to set a context for a request.
func NewWaypointExpediteStatusReportParamsWithContext(ctx context.Context) *WaypointExpediteStatusReportParams {
	return &WaypointExpediteStatusReportParams{
		Context: ctx,
	}
}

// NewWaypointExpediteStatusReportParamsWithHTTPClient creates a new WaypointExpediteStatusReportParams object
// with the ability to set a custom HTTPClient for a request.
func NewWaypointExpediteStatusReportParamsWithHTTPClient(client *http.Client) *WaypointExpediteStatusReportParams {
	return &WaypointExpediteStatusReportParams{
		HTTPClient: client,
	}
}

/*
WaypointExpediteStatusReportParams contains all the parameters to send to the API endpoint

	for the waypoint expedite status report operation.

	Typically these are written to a http.Request.
*/
type WaypointExpediteStatusReportParams struct {

	// Body.
	Body *models.HashicorpWaypointExpediteStatusReportRequest

	// DeploymentID.
	DeploymentID string

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the waypoint expedite status report params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *WaypointExpediteStatusReportParams) WithDefaults() *WaypointExpediteStatusReportParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the waypoint expedite status report params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *WaypointExpediteStatusReportParams) SetDefaults() {
	// no default values defined for this parameter
}

// WithTimeout adds the timeout to the waypoint expedite status report params
func (o *WaypointExpediteStatusReportParams) WithTimeout(timeout time.Duration) *WaypointExpediteStatusReportParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the waypoint expedite status report params
func (o *WaypointExpediteStatusReportParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the waypoint expedite status report params
func (o *WaypointExpediteStatusReportParams) WithContext(ctx context.Context) *WaypointExpediteStatusReportParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the waypoint expedite status report params
func (o *WaypointExpediteStatusReportParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the waypoint expedite status report params
func (o *WaypointExpediteStatusReportParams) WithHTTPClient(client *http.Client) *WaypointExpediteStatusReportParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the waypoint expedite status report params
func (o *WaypointExpediteStatusReportParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithBody adds the body to the waypoint expedite status report params
func (o *WaypointExpediteStatusReportParams) WithBody(body *models.HashicorpWaypointExpediteStatusReportRequest) *WaypointExpediteStatusReportParams {
	o.SetBody(body)
	return o
}

// SetBody adds the body to the waypoint expedite status report params
func (o *WaypointExpediteStatusReportParams) SetBody(body *models.HashicorpWaypointExpediteStatusReportRequest) {
	o.Body = body
}

// WithDeploymentID adds the deploymentID to the waypoint expedite status report params
func (o *WaypointExpediteStatusReportParams) WithDeploymentID(deploymentID string) *WaypointExpediteStatusReportParams {
	o.SetDeploymentID(deploymentID)
	return o
}

// SetDeploymentID adds the deploymentId to the waypoint expedite status report params
func (o *WaypointExpediteStatusReportParams) SetDeploymentID(deploymentID string) {
	o.DeploymentID = deploymentID
}

// WriteToRequest writes these params to a swagger request
func (o *WaypointExpediteStatusReportParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error
	if o.Body != nil {
		if err := r.SetBodyParam(o.Body); err != nil {
			return err
		}
	}

	// path param deployment.id
	if err := r.SetPathParam("deployment.id", o.DeploymentID); err != nil {
		return err
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
