// Code generated by go-swagger; DO NOT EDIT.

package waypoint

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"
)

// NewWaypointForgetRunnerParams creates a new WaypointForgetRunnerParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewWaypointForgetRunnerParams() *WaypointForgetRunnerParams {
	return &WaypointForgetRunnerParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewWaypointForgetRunnerParamsWithTimeout creates a new WaypointForgetRunnerParams object
// with the ability to set a timeout on a request.
func NewWaypointForgetRunnerParamsWithTimeout(timeout time.Duration) *WaypointForgetRunnerParams {
	return &WaypointForgetRunnerParams{
		timeout: timeout,
	}
}

// NewWaypointForgetRunnerParamsWithContext creates a new WaypointForgetRunnerParams object
// with the ability to set a context for a request.
func NewWaypointForgetRunnerParamsWithContext(ctx context.Context) *WaypointForgetRunnerParams {
	return &WaypointForgetRunnerParams{
		Context: ctx,
	}
}

// NewWaypointForgetRunnerParamsWithHTTPClient creates a new WaypointForgetRunnerParams object
// with the ability to set a custom HTTPClient for a request.
func NewWaypointForgetRunnerParamsWithHTTPClient(client *http.Client) *WaypointForgetRunnerParams {
	return &WaypointForgetRunnerParams{
		HTTPClient: client,
	}
}

/*
WaypointForgetRunnerParams contains all the parameters to send to the API endpoint

	for the waypoint forget runner operation.

	Typically these are written to a http.Request.
*/
type WaypointForgetRunnerParams struct {

	/* RunnerID.

	   ID of the runner to forget
	*/
	RunnerID string

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the waypoint forget runner params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *WaypointForgetRunnerParams) WithDefaults() *WaypointForgetRunnerParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the waypoint forget runner params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *WaypointForgetRunnerParams) SetDefaults() {
	// no default values defined for this parameter
}

// WithTimeout adds the timeout to the waypoint forget runner params
func (o *WaypointForgetRunnerParams) WithTimeout(timeout time.Duration) *WaypointForgetRunnerParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the waypoint forget runner params
func (o *WaypointForgetRunnerParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the waypoint forget runner params
func (o *WaypointForgetRunnerParams) WithContext(ctx context.Context) *WaypointForgetRunnerParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the waypoint forget runner params
func (o *WaypointForgetRunnerParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the waypoint forget runner params
func (o *WaypointForgetRunnerParams) WithHTTPClient(client *http.Client) *WaypointForgetRunnerParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the waypoint forget runner params
func (o *WaypointForgetRunnerParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithRunnerID adds the runnerID to the waypoint forget runner params
func (o *WaypointForgetRunnerParams) WithRunnerID(runnerID string) *WaypointForgetRunnerParams {
	o.SetRunnerID(runnerID)
	return o
}

// SetRunnerID adds the runnerId to the waypoint forget runner params
func (o *WaypointForgetRunnerParams) SetRunnerID(runnerID string) {
	o.RunnerID = runnerID
}

// WriteToRequest writes these params to a swagger request
func (o *WaypointForgetRunnerParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error

	// path param runner_id
	if err := r.SetPathParam("runner_id", o.RunnerID); err != nil {
		return err
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
