// Code generated by go-swagger; DO NOT EDIT.

package waypoint

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"
)

// NewWaypointListPipelinesParams creates a new WaypointListPipelinesParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewWaypointListPipelinesParams() *WaypointListPipelinesParams {
	return &WaypointListPipelinesParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewWaypointListPipelinesParamsWithTimeout creates a new WaypointListPipelinesParams object
// with the ability to set a timeout on a request.
func NewWaypointListPipelinesParamsWithTimeout(timeout time.Duration) *WaypointListPipelinesParams {
	return &WaypointListPipelinesParams{
		timeout: timeout,
	}
}

// NewWaypointListPipelinesParamsWithContext creates a new WaypointListPipelinesParams object
// with the ability to set a context for a request.
func NewWaypointListPipelinesParamsWithContext(ctx context.Context) *WaypointListPipelinesParams {
	return &WaypointListPipelinesParams{
		Context: ctx,
	}
}

// NewWaypointListPipelinesParamsWithHTTPClient creates a new WaypointListPipelinesParams object
// with the ability to set a custom HTTPClient for a request.
func NewWaypointListPipelinesParamsWithHTTPClient(client *http.Client) *WaypointListPipelinesParams {
	return &WaypointListPipelinesParams{
		HTTPClient: client,
	}
}

/*
WaypointListPipelinesParams contains all the parameters to send to the API endpoint

	for the waypoint list pipelines operation.

	Typically these are written to a http.Request.
*/
type WaypointListPipelinesParams struct {

	// ProjectProject.
	ProjectProject string

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the waypoint list pipelines params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *WaypointListPipelinesParams) WithDefaults() *WaypointListPipelinesParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the waypoint list pipelines params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *WaypointListPipelinesParams) SetDefaults() {
	// no default values defined for this parameter
}

// WithTimeout adds the timeout to the waypoint list pipelines params
func (o *WaypointListPipelinesParams) WithTimeout(timeout time.Duration) *WaypointListPipelinesParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the waypoint list pipelines params
func (o *WaypointListPipelinesParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the waypoint list pipelines params
func (o *WaypointListPipelinesParams) WithContext(ctx context.Context) *WaypointListPipelinesParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the waypoint list pipelines params
func (o *WaypointListPipelinesParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the waypoint list pipelines params
func (o *WaypointListPipelinesParams) WithHTTPClient(client *http.Client) *WaypointListPipelinesParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the waypoint list pipelines params
func (o *WaypointListPipelinesParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithProjectProject adds the projectProject to the waypoint list pipelines params
func (o *WaypointListPipelinesParams) WithProjectProject(projectProject string) *WaypointListPipelinesParams {
	o.SetProjectProject(projectProject)
	return o
}

// SetProjectProject adds the projectProject to the waypoint list pipelines params
func (o *WaypointListPipelinesParams) SetProjectProject(projectProject string) {
	o.ProjectProject = projectProject
}

// WriteToRequest writes these params to a swagger request
func (o *WaypointListPipelinesParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error

	// path param project.project
	if err := r.SetPathParam("project.project", o.ProjectProject); err != nil {
		return err
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
