// Code generated by go-swagger; DO NOT EDIT.

package waypoint

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"
)

// NewWaypointListWorkspaces2Params creates a new WaypointListWorkspaces2Params object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewWaypointListWorkspaces2Params() *WaypointListWorkspaces2Params {
	return &WaypointListWorkspaces2Params{
		timeout: cr.DefaultTimeout,
	}
}

// NewWaypointListWorkspaces2ParamsWithTimeout creates a new WaypointListWorkspaces2Params object
// with the ability to set a timeout on a request.
func NewWaypointListWorkspaces2ParamsWithTimeout(timeout time.Duration) *WaypointListWorkspaces2Params {
	return &WaypointListWorkspaces2Params{
		timeout: timeout,
	}
}

// NewWaypointListWorkspaces2ParamsWithContext creates a new WaypointListWorkspaces2Params object
// with the ability to set a context for a request.
func NewWaypointListWorkspaces2ParamsWithContext(ctx context.Context) *WaypointListWorkspaces2Params {
	return &WaypointListWorkspaces2Params{
		Context: ctx,
	}
}

// NewWaypointListWorkspaces2ParamsWithHTTPClient creates a new WaypointListWorkspaces2Params object
// with the ability to set a custom HTTPClient for a request.
func NewWaypointListWorkspaces2ParamsWithHTTPClient(client *http.Client) *WaypointListWorkspaces2Params {
	return &WaypointListWorkspaces2Params{
		HTTPClient: client,
	}
}

/*
WaypointListWorkspaces2Params contains all the parameters to send to the API endpoint

	for the waypoint list workspaces2 operation.

	Typically these are written to a http.Request.
*/
type WaypointListWorkspaces2Params struct {

	// ApplicationApplication.
	ApplicationApplication *string

	// ApplicationProject.
	ApplicationProject *string

	// ProjectProject.
	ProjectProject string

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the waypoint list workspaces2 params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *WaypointListWorkspaces2Params) WithDefaults() *WaypointListWorkspaces2Params {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the waypoint list workspaces2 params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *WaypointListWorkspaces2Params) SetDefaults() {
	// no default values defined for this parameter
}

// WithTimeout adds the timeout to the waypoint list workspaces2 params
func (o *WaypointListWorkspaces2Params) WithTimeout(timeout time.Duration) *WaypointListWorkspaces2Params {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the waypoint list workspaces2 params
func (o *WaypointListWorkspaces2Params) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the waypoint list workspaces2 params
func (o *WaypointListWorkspaces2Params) WithContext(ctx context.Context) *WaypointListWorkspaces2Params {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the waypoint list workspaces2 params
func (o *WaypointListWorkspaces2Params) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the waypoint list workspaces2 params
func (o *WaypointListWorkspaces2Params) WithHTTPClient(client *http.Client) *WaypointListWorkspaces2Params {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the waypoint list workspaces2 params
func (o *WaypointListWorkspaces2Params) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithApplicationApplication adds the applicationApplication to the waypoint list workspaces2 params
func (o *WaypointListWorkspaces2Params) WithApplicationApplication(applicationApplication *string) *WaypointListWorkspaces2Params {
	o.SetApplicationApplication(applicationApplication)
	return o
}

// SetApplicationApplication adds the applicationApplication to the waypoint list workspaces2 params
func (o *WaypointListWorkspaces2Params) SetApplicationApplication(applicationApplication *string) {
	o.ApplicationApplication = applicationApplication
}

// WithApplicationProject adds the applicationProject to the waypoint list workspaces2 params
func (o *WaypointListWorkspaces2Params) WithApplicationProject(applicationProject *string) *WaypointListWorkspaces2Params {
	o.SetApplicationProject(applicationProject)
	return o
}

// SetApplicationProject adds the applicationProject to the waypoint list workspaces2 params
func (o *WaypointListWorkspaces2Params) SetApplicationProject(applicationProject *string) {
	o.ApplicationProject = applicationProject
}

// WithProjectProject adds the projectProject to the waypoint list workspaces2 params
func (o *WaypointListWorkspaces2Params) WithProjectProject(projectProject string) *WaypointListWorkspaces2Params {
	o.SetProjectProject(projectProject)
	return o
}

// SetProjectProject adds the projectProject to the waypoint list workspaces2 params
func (o *WaypointListWorkspaces2Params) SetProjectProject(projectProject string) {
	o.ProjectProject = projectProject
}

// WriteToRequest writes these params to a swagger request
func (o *WaypointListWorkspaces2Params) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error

	if o.ApplicationApplication != nil {

		// query param application.application
		var qrApplicationApplication string

		if o.ApplicationApplication != nil {
			qrApplicationApplication = *o.ApplicationApplication
		}
		qApplicationApplication := qrApplicationApplication
		if qApplicationApplication != "" {

			if err := r.SetQueryParam("application.application", qApplicationApplication); err != nil {
				return err
			}
		}
	}

	if o.ApplicationProject != nil {

		// query param application.project
		var qrApplicationProject string

		if o.ApplicationProject != nil {
			qrApplicationProject = *o.ApplicationProject
		}
		qApplicationProject := qrApplicationProject
		if qApplicationProject != "" {

			if err := r.SetQueryParam("application.project", qApplicationProject); err != nil {
				return err
			}
		}
	}

	// path param project.project
	if err := r.SetPathParam("project.project", o.ProjectProject); err != nil {
		return err
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
