// Code generated by go-swagger; DO NOT EDIT.

package waypoint

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"
)

// NewWaypointListWorkspaces3Params creates a new WaypointListWorkspaces3Params object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewWaypointListWorkspaces3Params() *WaypointListWorkspaces3Params {
	return &WaypointListWorkspaces3Params{
		timeout: cr.DefaultTimeout,
	}
}

// NewWaypointListWorkspaces3ParamsWithTimeout creates a new WaypointListWorkspaces3Params object
// with the ability to set a timeout on a request.
func NewWaypointListWorkspaces3ParamsWithTimeout(timeout time.Duration) *WaypointListWorkspaces3Params {
	return &WaypointListWorkspaces3Params{
		timeout: timeout,
	}
}

// NewWaypointListWorkspaces3ParamsWithContext creates a new WaypointListWorkspaces3Params object
// with the ability to set a context for a request.
func NewWaypointListWorkspaces3ParamsWithContext(ctx context.Context) *WaypointListWorkspaces3Params {
	return &WaypointListWorkspaces3Params{
		Context: ctx,
	}
}

// NewWaypointListWorkspaces3ParamsWithHTTPClient creates a new WaypointListWorkspaces3Params object
// with the ability to set a custom HTTPClient for a request.
func NewWaypointListWorkspaces3ParamsWithHTTPClient(client *http.Client) *WaypointListWorkspaces3Params {
	return &WaypointListWorkspaces3Params{
		HTTPClient: client,
	}
}

/*
WaypointListWorkspaces3Params contains all the parameters to send to the API endpoint

	for the waypoint list workspaces3 operation.

	Typically these are written to a http.Request.
*/
type WaypointListWorkspaces3Params struct {

	// ApplicationApplication.
	ApplicationApplication string

	// ApplicationProject.
	ApplicationProject string

	// ProjectProject.
	ProjectProject *string

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the waypoint list workspaces3 params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *WaypointListWorkspaces3Params) WithDefaults() *WaypointListWorkspaces3Params {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the waypoint list workspaces3 params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *WaypointListWorkspaces3Params) SetDefaults() {
	// no default values defined for this parameter
}

// WithTimeout adds the timeout to the waypoint list workspaces3 params
func (o *WaypointListWorkspaces3Params) WithTimeout(timeout time.Duration) *WaypointListWorkspaces3Params {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the waypoint list workspaces3 params
func (o *WaypointListWorkspaces3Params) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the waypoint list workspaces3 params
func (o *WaypointListWorkspaces3Params) WithContext(ctx context.Context) *WaypointListWorkspaces3Params {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the waypoint list workspaces3 params
func (o *WaypointListWorkspaces3Params) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the waypoint list workspaces3 params
func (o *WaypointListWorkspaces3Params) WithHTTPClient(client *http.Client) *WaypointListWorkspaces3Params {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the waypoint list workspaces3 params
func (o *WaypointListWorkspaces3Params) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithApplicationApplication adds the applicationApplication to the waypoint list workspaces3 params
func (o *WaypointListWorkspaces3Params) WithApplicationApplication(applicationApplication string) *WaypointListWorkspaces3Params {
	o.SetApplicationApplication(applicationApplication)
	return o
}

// SetApplicationApplication adds the applicationApplication to the waypoint list workspaces3 params
func (o *WaypointListWorkspaces3Params) SetApplicationApplication(applicationApplication string) {
	o.ApplicationApplication = applicationApplication
}

// WithApplicationProject adds the applicationProject to the waypoint list workspaces3 params
func (o *WaypointListWorkspaces3Params) WithApplicationProject(applicationProject string) *WaypointListWorkspaces3Params {
	o.SetApplicationProject(applicationProject)
	return o
}

// SetApplicationProject adds the applicationProject to the waypoint list workspaces3 params
func (o *WaypointListWorkspaces3Params) SetApplicationProject(applicationProject string) {
	o.ApplicationProject = applicationProject
}

// WithProjectProject adds the projectProject to the waypoint list workspaces3 params
func (o *WaypointListWorkspaces3Params) WithProjectProject(projectProject *string) *WaypointListWorkspaces3Params {
	o.SetProjectProject(projectProject)
	return o
}

// SetProjectProject adds the projectProject to the waypoint list workspaces3 params
func (o *WaypointListWorkspaces3Params) SetProjectProject(projectProject *string) {
	o.ProjectProject = projectProject
}

// WriteToRequest writes these params to a swagger request
func (o *WaypointListWorkspaces3Params) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error

	// path param application.application
	if err := r.SetPathParam("application.application", o.ApplicationApplication); err != nil {
		return err
	}

	// path param application.project
	if err := r.SetPathParam("application.project", o.ApplicationProject); err != nil {
		return err
	}

	if o.ProjectProject != nil {

		// query param project.project
		var qrProjectProject string

		if o.ProjectProject != nil {
			qrProjectProject = *o.ProjectProject
		}
		qProjectProject := qrProjectProject
		if qProjectProject != "" {

			if err := r.SetQueryParam("project.project", qProjectProject); err != nil {
				return err
			}
		}
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
