// Code generated by go-swagger; DO NOT EDIT.

package waypoint

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"

	"github.com/hashicorp/waypoint/pkg/client/gen/models"
)

// NewWaypointSetServerConfigParams creates a new WaypointSetServerConfigParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewWaypointSetServerConfigParams() *WaypointSetServerConfigParams {
	return &WaypointSetServerConfigParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewWaypointSetServerConfigParamsWithTimeout creates a new WaypointSetServerConfigParams object
// with the ability to set a timeout on a request.
func NewWaypointSetServerConfigParamsWithTimeout(timeout time.Duration) *WaypointSetServerConfigParams {
	return &WaypointSetServerConfigParams{
		timeout: timeout,
	}
}

// NewWaypointSetServerConfigParamsWithContext creates a new WaypointSetServerConfigParams object
// with the ability to set a context for a request.
func NewWaypointSetServerConfigParamsWithContext(ctx context.Context) *WaypointSetServerConfigParams {
	return &WaypointSetServerConfigParams{
		Context: ctx,
	}
}

// NewWaypointSetServerConfigParamsWithHTTPClient creates a new WaypointSetServerConfigParams object
// with the ability to set a custom HTTPClient for a request.
func NewWaypointSetServerConfigParamsWithHTTPClient(client *http.Client) *WaypointSetServerConfigParams {
	return &WaypointSetServerConfigParams{
		HTTPClient: client,
	}
}

/*
WaypointSetServerConfigParams contains all the parameters to send to the API endpoint

	for the waypoint set server config operation.

	Typically these are written to a http.Request.
*/
type WaypointSetServerConfigParams struct {

	// Body.
	Body *models.HashicorpWaypointSetServerConfigRequest

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the waypoint set server config params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *WaypointSetServerConfigParams) WithDefaults() *WaypointSetServerConfigParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the waypoint set server config params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *WaypointSetServerConfigParams) SetDefaults() {
	// no default values defined for this parameter
}

// WithTimeout adds the timeout to the waypoint set server config params
func (o *WaypointSetServerConfigParams) WithTimeout(timeout time.Duration) *WaypointSetServerConfigParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the waypoint set server config params
func (o *WaypointSetServerConfigParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the waypoint set server config params
func (o *WaypointSetServerConfigParams) WithContext(ctx context.Context) *WaypointSetServerConfigParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the waypoint set server config params
func (o *WaypointSetServerConfigParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the waypoint set server config params
func (o *WaypointSetServerConfigParams) WithHTTPClient(client *http.Client) *WaypointSetServerConfigParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the waypoint set server config params
func (o *WaypointSetServerConfigParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithBody adds the body to the waypoint set server config params
func (o *WaypointSetServerConfigParams) WithBody(body *models.HashicorpWaypointSetServerConfigRequest) *WaypointSetServerConfigParams {
	o.SetBody(body)
	return o
}

// SetBody adds the body to the waypoint set server config params
func (o *WaypointSetServerConfigParams) SetBody(body *models.HashicorpWaypointSetServerConfigRequest) {
	o.Body = body
}

// WriteToRequest writes these params to a swagger request
func (o *WaypointSetServerConfigParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error
	if o.Body != nil {
		if err := r.SetBodyParam(o.Body); err != nil {
			return err
		}
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
