// Code generated by go-swagger; DO NOT EDIT.

package waypoint

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"

	"github.com/hashicorp/waypoint/pkg/client/gen/models"
)

// NewWaypointStartExecStreamParams creates a new WaypointStartExecStreamParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewWaypointStartExecStreamParams() *WaypointStartExecStreamParams {
	return &WaypointStartExecStreamParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewWaypointStartExecStreamParamsWithTimeout creates a new WaypointStartExecStreamParams object
// with the ability to set a timeout on a request.
func NewWaypointStartExecStreamParamsWithTimeout(timeout time.Duration) *WaypointStartExecStreamParams {
	return &WaypointStartExecStreamParams{
		timeout: timeout,
	}
}

// NewWaypointStartExecStreamParamsWithContext creates a new WaypointStartExecStreamParams object
// with the ability to set a context for a request.
func NewWaypointStartExecStreamParamsWithContext(ctx context.Context) *WaypointStartExecStreamParams {
	return &WaypointStartExecStreamParams{
		Context: ctx,
	}
}

// NewWaypointStartExecStreamParamsWithHTTPClient creates a new WaypointStartExecStreamParams object
// with the ability to set a custom HTTPClient for a request.
func NewWaypointStartExecStreamParamsWithHTTPClient(client *http.Client) *WaypointStartExecStreamParams {
	return &WaypointStartExecStreamParams{
		HTTPClient: client,
	}
}

/*
WaypointStartExecStreamParams contains all the parameters to send to the API endpoint

	for the waypoint start exec stream operation.

	Typically these are written to a http.Request.
*/
type WaypointStartExecStreamParams struct {

	/* Body.

	   (streaming inputs)
	*/
	Body *models.HashicorpWaypointExecStreamRequest

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the waypoint start exec stream params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *WaypointStartExecStreamParams) WithDefaults() *WaypointStartExecStreamParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the waypoint start exec stream params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *WaypointStartExecStreamParams) SetDefaults() {
	// no default values defined for this parameter
}

// WithTimeout adds the timeout to the waypoint start exec stream params
func (o *WaypointStartExecStreamParams) WithTimeout(timeout time.Duration) *WaypointStartExecStreamParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the waypoint start exec stream params
func (o *WaypointStartExecStreamParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the waypoint start exec stream params
func (o *WaypointStartExecStreamParams) WithContext(ctx context.Context) *WaypointStartExecStreamParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the waypoint start exec stream params
func (o *WaypointStartExecStreamParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the waypoint start exec stream params
func (o *WaypointStartExecStreamParams) WithHTTPClient(client *http.Client) *WaypointStartExecStreamParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the waypoint start exec stream params
func (o *WaypointStartExecStreamParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithBody adds the body to the waypoint start exec stream params
func (o *WaypointStartExecStreamParams) WithBody(body *models.HashicorpWaypointExecStreamRequest) *WaypointStartExecStreamParams {
	o.SetBody(body)
	return o
}

// SetBody adds the body to the waypoint start exec stream params
func (o *WaypointStartExecStreamParams) SetBody(body *models.HashicorpWaypointExecStreamRequest) {
	o.Body = body
}

// WriteToRequest writes these params to a swagger request
func (o *WaypointStartExecStreamParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error
	if o.Body != nil {
		if err := r.SetBodyParam(o.Body); err != nil {
			return err
		}
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
