// Code generated by go-swagger; DO NOT EDIT.

package models

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"

	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"
)

// HashicorpWaypointTaskLaunchInfo TaskLaunchInfo gets stored on the job/operation when queued for execution.
// It details various options required for the task it will launch.
//
// swagger:model hashicorp.waypoint.TaskLaunchInfo
type HashicorpWaypointTaskLaunchInfo struct {

	// The arguments that will be passed to the new container on boot.
	// These are arguments and should not overwrite the entrypoint.
	Arguments []string `json:"arguments"`

	// Entrypoint is the entrypoint override for the OCI image. If this
	// is not set (null or length of zero) then the entrypoint should not
	// be overridden.
	Entrypoint []string `json:"entrypoint"`

	// The environment variables that will be exposed to the task.
	EnvironmentVariables map[string]string `json:"environment_variables,omitempty"`

	// The URL of the OCI image to execute the task under.
	OciURL string `json:"oci_url,omitempty"`
}

// Validate validates this hashicorp waypoint task launch info
func (m *HashicorpWaypointTaskLaunchInfo) Validate(formats strfmt.Registry) error {
	return nil
}

// ContextValidate validates this hashicorp waypoint task launch info based on context it is used
func (m *HashicorpWaypointTaskLaunchInfo) ContextValidate(ctx context.Context, formats strfmt.Registry) error {
	return nil
}

// MarshalBinary interface implementation
func (m *HashicorpWaypointTaskLaunchInfo) MarshalBinary() ([]byte, error) {
	if m == nil {
		return nil, nil
	}
	return swag.WriteJSON(m)
}

// UnmarshalBinary interface implementation
func (m *HashicorpWaypointTaskLaunchInfo) UnmarshalBinary(b []byte) error {
	var res HashicorpWaypointTaskLaunchInfo
	if err := swag.ReadJSON(b, &res); err != nil {
		return err
	}
	*m = res
	return nil
}
